import PropTypes from 'prop-types';
import React from 'react';
import Notebook from './component';

export default class StandaloneApp extends React.Component {
  static propTypes = {
    content: PropTypes.string,
    blockNumber: PropTypes.number,
    sandbox: PropTypes.object
  };

  constructor(props) {
    super(props);

    this.state = {
      notebookState: {
        content: this.props.content
      }
    };
  }

  handleChange = (notebookState) => {
    this.setState({
      notebookState
    });
  }

  handleExecute = () => {
    const {
      notebookState
    } = this.state;
    const {
      blockNumber,
      sandbox
    } = this.props;

    this.handleChange({ ...notebookState, isLoading: true });

    return sandbox.execute(notebookState.content, blockNumber)
      .then((exec) => {
        this.handleChange({ ...notebookState, exec, isLoading: false });
      });
  }

  render() {
    const {
      blockNumber
    } = this.props;
    const {
      notebookState
    } = this.state;

    return (
      <Notebook
        blockNumber={blockNumber}
        notebookState={notebookState}
        onChange={this.handleChange}
      />
    );
  }
}
